indexing

   description: "Abstract factory to create POSIX or Windows classes."
   
   usage: "Use the effective class EPX_FACTORY for your OS."
   
   author: "Berend de Boer"
   date: "$Date: "
   revision: "$Revision: #1 $"
   
   
deferred class 

   ABSTRACT_FACTORY
   
   
feature -- file system
   
   fs: ABSTRACT_FILE_SYSTEM is
      deferred
      end
   
   
feature -- binary/text file open mode
   
   is_binary_mode: BOOLEAN is
         -- what's the current open mode?
         -- Always True for POSIX (not really applicable there)
      deferred
      end

   set_binary_mode (value: BOOLEAN) is
         -- set mode in which to open files: binary or text. Is not
         -- applicable with POSIX, but an important distinction in Windows.
         -- default mode is text.
      deferred
      ensure
         binary_mode_set: value implies is_binary_mode
      end
   

feature -- file descriptor
   
   create_with_mode (a_path: STRING; flags, mode: INTEGER): ABSTRACT_FILE_DESCRIPTOR is
      deferred
      end
   
   create_write (a_path: STRING): ABSTRACT_FILE_DESCRIPTOR is
      deferred
      end
   
   create_read_write (a_path: STRING): ABSTRACT_FILE_DESCRIPTOR is
      deferred
      end
      
   open (a_path: STRING; a_flags: INTEGER): ABSTRACT_FILE_DESCRIPTOR is
      deferred
      end
   
   open_read (a_path: STRING): ABSTRACT_FILE_DESCRIPTOR is
      deferred
      end
   
   open_read_write (a_path: STRING): ABSTRACT_FILE_DESCRIPTOR is
      deferred
      end
   
   open_truncate (a_path: STRING): ABSTRACT_FILE_DESCRIPTOR is
      deferred
      end
   
   open_write (a_path: STRING): ABSTRACT_FILE_DESCRIPTOR is
      deferred
      end

   
feature  -- pipe
   
   
feature  -- socket
   
   
end -- class ABSTRACT_FACTORY
